//+------------------------------------------------------------------+
//|                                        SuperTrend volty like.mq4 |
//|                                                           Mladen |
//| initial idea by jntrader                                         |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0
#property indicator_maximum 1


extern string TimeFrame        = "Current time frame";
extern string ForSymbol        = "";
extern int    period           = 10;
extern int    appliedPrice     = PRICE_CLOSE;
extern double multiplier       = 4.0;
extern bool   invert           = false;
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

//
//
//
//
//

double TrendU[];
double TrendHU[];
double TrendD[];
double TrendHD[];
double Direction[];
double Up[];
double Dn[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0, TrendHU); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1, TrendHD); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2, TrendU);
      SetIndexBuffer(3, TrendD);
      SetIndexBuffer(4, Direction);
      SetIndexBuffer(5, Up);
      SetIndexBuffer(6, Dn);

      period = MathMax(1,period);
         if (ForSymbol=="") ForSymbol=Symbol();
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars";     if (returnBars)     { return(0); }
         calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         
   
   IndicatorShortName(ForSymbol+" SuperTrend");
   return(0);
}
int deinit()
{
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { TrendHU[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
     
   if (calculateValue || (timeFrame == Period() && ForSymbol==Symbol()))
   {
      for(int i = limit; i >= 0; i--)
      {
         double atr    = iATR(NULL,0,period,i);
         double cprice = iMA(NULL,0,1,0,MODE_SMA,appliedPrice,i);
         double mprice = (High[i]+Low[i])/2;
             Up[i]  = mprice+multiplier*atr;
             Dn[i]  = mprice-multiplier*atr;
         
         //
         //
         //
         //
         //
         
         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;

         TrendU[i]  = EMPTY_VALUE;
         TrendHU[i] = EMPTY_VALUE;
         TrendD[i]  = EMPTY_VALUE;
         TrendHD[i] = EMPTY_VALUE;
         
            if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); TrendU[i] = Dn[i]; if (invert) TrendHD[i] = 1; else TrendHU[i] = 1; }
            else                  { Up[i] = MathMin(Up[i],Up[i+1]); TrendD[i] = Up[i]; if (invert) TrendHU[i] = 1; else TrendHD[i] = 1; }
      }
      if (alertsOn)
      {
         
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (Direction[whichBar] != Direction[whichBar+1])
         if (Direction[whichBar] == 1)
               doAlert("up trend");
         else  doAlert("down trend");       
      }   
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(ForSymbol,timeFrame,Time[i]);               
          TrendHU[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",period,appliedPrice,multiplier,invert,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,0,y);
          TrendHD[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",period,appliedPrice,multiplier,invert,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,1,y);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SuperTrend ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SuperTrend "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}